const SetNameDecorator = (firstName: string, secondName: string) => {
    const name = `${firstName} ${secondName}`;
    return <T extends new (...args: any[]) => any>(target: T) => {
        return class extends target {
            _name: string = name;
            getMyname() {
                return this._name;
            }
        }
    }
}

@SetNameDecorator('zeng', 'leon')
class UserService {
    [key: string]: any;
    c() { }
}

export const exp3 = () => {
    const userService = new UserService();
    console.log(userService.getMyname());
}