type UserProfile = Record<string, any> & {
    phone?: number;
    address?: string;
}

const ProfileDecorator = (profile: UserProfile) => (target: any) => {
    const Original = target;
    let userinfo = '';
    Object.keys(profile).forEach(key => {
        userinfo += `${key}: ${profile[key]}\n`;
    })

    Original.prototype.userinfo = userinfo;
    function constructor(...args: any[]) {
        console.log('construct has been called');
        return new Original(...args);
    }
    constructor.prototype = Original.prototype;
    constructor.myinfo = `myinfo ${userinfo}`
    return constructor as typeof Original;
}

@ProfileDecorator({
    phone: 1234567890,
    address: 'zhongguo'
})
class User { }

export const exp4 = () => {
    console.log("------------exp4-----------")
    const user = new User();
    console.log((user as any).userinfo);
}