const HelloDerorator = <T extends new (...args: any[]) => any>(constructor: T) => {
    return class extends constructor {
        newProperty = 'new property';
        hello = 'override';
        sayHello() {
            return this.hello;
        }
    };
};
@HelloDerorator
export class Hello {
    [key: string]: any;
    hello: string;
    constructor() {
        this.hello = 'hello';
    }
}

export const exp2 = () => {
    const hello = new Hello();
    console.log(hello.sayHello());
};
